package tech.lp2p.quic;

import java.net.InetSocketAddress;
import java.nio.ByteBuffer;
import java.util.Arrays;
import java.util.concurrent.atomic.AtomicReference;

import tech.lp2p.tls.DecodeErrorException;
import tech.lp2p.tls.DecryptErrorAlert;
import tech.lp2p.utils.Utils;

/**
 * A server connection candidate: whether an initial packet causes a new server connection to be created cannot be
 * decided until the initial packet has been successfully parsed and decrypted (to avoid that corrupt packets change
 * server state).
 */
final class ServerConnectionCandidate implements ConnectionProxy {
    private final Version quicVersion;
    private final InetSocketAddress remoteAddress;
    private final byte[] dcid;
    private final ServerConnector serverConnector;
    private final AtomicReference<ServerConnection> registeredConnection
            = new AtomicReference<>();


    ServerConnectionCandidate(ServerConnector serverConnector, Version version,
                              InetSocketAddress remoteAddress, byte[] dcid) {
        this.serverConnector = serverConnector;
        this.quicVersion = version;
        this.remoteAddress = remoteAddress;
        this.dcid = dcid;
    }

    @Override
    public InetSocketAddress remoteAddress() {
        return remoteAddress;
    }

    @Override
    public void parsePackets(long timeReceived, ByteBuffer data) {
        // Execute packet parsing on separate thread, to make this method return a.s.a.p.
        ServerConnection connection = registeredConnection.get();
        if (connection != null) {
            connection.parsePackets(timeReceived, data);
            return;
        }

        try {
            PacketReceived.Initial initialPacket = parseInitialPacket(data);
            // Packet is valid. This is the moment to create a real
            // server connection and continue processing.
            data.rewind();
            createAndRegisterServerConnection(initialPacket, timeReceived, data);
        } catch (Throwable error) {
            // Drop packet without any action (i.e. do not send anything; do not change state;
            // avoid unnecessary processing)
            Utils.error("Dropped invalid initial packet (no connection created) " + error.getMessage());
            serverConnector.deregisterConnection(this, dcid);
        }

    }

    private void createAndRegisterServerConnection(PacketReceived.Initial initialPacket,
                                                   long timeReceived, ByteBuffer data) {
        Version quicVersion = initialPacket.version();
        byte[] originalDcid = initialPacket.destinationConnectionId();
        ServerConnection serverConnection = createNewConnection(quicVersion,
                remoteAddress, initialPacket.sourceConnectionId(), originalDcid);
        registeredConnection.set(serverConnection);

        // Pass the initial packet for processing, so it is processed on the server thread
        // (enabling thread confinement concurrency strategy)
        serverConnection.parseAndProcessPackets(timeReceived, data, initialPacket);

        // Register new connection with the new connection id (the one generated by the server)
        serverConnector.registerConnection(serverConnection, serverConnection.activeSourceCid());
    }


    @Override
    public void terminate() {
        // nothing to do here
    }


    private ServerConnection createNewConnection(
            Version version, InetSocketAddress clientAddress,
            byte[] scid, byte[] originalDcid) {

        return new ServerConnection(serverConnector, version,
                clientAddress, scid, originalDcid,
                datagram -> Utils.debug("Datagram " + Arrays.toString(datagram)));
    }

    private PacketReceived.Initial parseInitialPacket(ByteBuffer data)
            throws DecodeErrorException, DecryptErrorAlert {
        // https://tools.ietf.org/html/draft-ietf-quic-transport-34#section-14.1
        // "A server MUST discard an Initial packet that is carried in a UDP datagram with a payload that is smaller than
        //  the smallest allowedmaximum datagram size of 1200 bytes."
        if (data.limit() < 1200) {
            throw new DecodeErrorException("Initial packets is carried in a datagram that is smaller than 1200 (" + data.limit() + ")");
        }

        int posFlags = data.position();
        // Note that the caller already has extracted connection id's from the raw data, so checking for minimal length is not necessary here.
        byte flags = data.get();

        if ((flags & 0x40) != 0x40) {
            // https://tools.ietf.org/html/draft-ietf-quic-transport-34#section-17.2
            // "Fixed Bit:  The next bit (0x40) of byte 0 is set to 1, unless the packet is a Version Negotiation packet.
            //  Packets containing a zero value for this bit are not valid packets in this version and MUST be discarded."
            throw new DecodeErrorException("The next bit (0x40) of byte 0 is set to 1");
        }

        int version = data.getInt();

        boolean matchingVersion = Version.parse(version).equals(quicVersion);
        if (!matchingVersion) {
            // https://tools.ietf.org/html/draft-ietf-quic-transport-27#section-5.2
            // "... packets are discarded if they indicate a different protocol version than that of the connection..."
            throw new DecodeErrorException("Version does not match version of the connection");
        }

        // https://tools.ietf.org/html/draft-ietf-quic-transport-34#section-17.2
        // "The most significant bit (0x80) of byte 0 (the first byte) is set to 1 for long headers."
        // https://tools.ietf.org/html/draft-ietf-quic-transport-34#section-17.2.2
        // "An Initial packet uses long headers with a payloadType value of 0x0."
        if (PacketParser.isInitial((flags & 0x30) >> 4, quicVersion)) {
            ConnectionSecrets connectionSecrets = new ConnectionSecrets(quicVersion, Role.Server);
            connectionSecrets.computeInitialKeys(dcid);
            Keys keys = connectionSecrets.remoteSecrets(Level.Initial);
            PacketHeader packetHeader = PacketParser.parseInitialPacketHeader(data, flags, posFlags, quicVersion);
            return (PacketReceived.Initial) PacketParser.parseInitial(
                    packetHeader, data, keys, 0, null);
        }
        throw new DecodeErrorException("not an initial packet");
    }
}
